var componentsModule = require('../components.module');
componentsModule.directive('chatAttachTo', [function () {

    //Attach sidebar to the element specified
    var attachToElement = function (sidebar, attached) {
        var wOffset = $(window).scrollTop();
        var attachedHeight = $(attached.selector).height();
        if (wOffset > attachedHeight)
            $(sidebar.selector).css('top', 0);
        else if (wOffset < attachedHeight)
            $(sidebar.selector).css('top', (attachedHeight - wOffset) - 1);
    };

    var onElementHeightChange = function (elm, callback) {
        var lastHeight = elm.clientHeight, newHeight;
        (function run() {
            newHeight = elm.clientHeight;
            if (lastHeight != newHeight)
                callback();
            lastHeight = newHeight;

            if (elm.onElementHeightChangeTimer)
                clearTimeout(elm.onElementHeightChangeTimer);

            elm.onElementHeightChangeTimer = setTimeout(run, 200);
        })();
    };

    return {
        restrict: 'A',
        link: function (scope, element, attrs) {
            if (attrs.chatAttachTo != "") {

                var $sidebar = $('.chat-sidebar');
                var $attachedElement = $(attrs.chatAttachTo);

                onElementHeightChange(document.body, function () {
                    attachToElement($sidebar, $attachedElement);
                });

                $(document).on('ready scroll', function () {
                    attachToElement($sidebar, $attachedElement);
                });

                window.inGaiaChat_API.on('chatSettingsLoaded', function (settings) {
                    if (!settings.collapsed)
                        attachToElement($sidebar, $attachedElement);
                });

                window.inGaiaChat_API.on('chatUpdateWidgetPosition', function () {
                    attachToElement($sidebar, $attachedElement);
                });

            }
        }
    }
}]);
