var componentsModules = require('../components.module');
componentsModules.directive('chatAutoScroll', ['$timeout', '$compile', function ($timeout, $compile) {
    return {
        restrict: 'EA',
        scope: {
            list: '=?data',
            action: '=?action',
            inverse: '=?inverse',
            scrollButton: '=?scrollButton'
        },
        link: function (scope, element) {

            var raw, scrollBottom, shouldScrollBottom, offsetScroll;

            raw = element[0];
            shouldScrollBottom = true;
            offsetScroll = 50;

            scrollBottom = function () {
                raw.scrollTop = raw.scrollHeight;
            };

            if (scope.scrollButton) {
                if (!angular.element(element)[0].querySelector('.auto-scroll-button')) {
                    var autoScrollButton = $compile('<div class="auto-scroll-button"><i class="ing ing-chevron-light-down"></i></div>')(scope)[0];
                    autoScrollButton.addEventListener('click', function () {
                        raw.scrollTop = raw.scrollHeight;
                    });
                    angular.element(element).after(autoScrollButton);
                }
            }

            element.bind('scroll', function () {


                shouldScrollBottom = Math.floor(raw.scrollTop + raw.offsetHeight + offsetScroll) >= raw.scrollHeight;

                if (scope.inverse) {
                    if (raw.scrollTop == 0) {
                        if (scope.action != undefined) {
                            scope.action();
                            raw.scrollTop = 10;
                        } else {
                            raw.scrollTop = 0;
                        }
                    }

                    if (scope.scrollButton) {
                        if (raw.scrollTop + raw.offsetHeight < raw.scrollHeight)
                            angular.element(element).parent().find('.auto-scroll-button').addClass('show');
                        else
                            angular.element(element).parent().find('.auto-scroll-button').removeClass('show');
                    }

                } else {
                    if ((raw.scrollTop + raw.offsetHeight >= raw.scrollHeight) && scope.action != undefined)
                        scope.action();
                }
            });

            scope.$watchCollection('list.length', function (n) {
                if (shouldScrollBottom) {
                    $timeout(scrollBottom, 200);
                }
            }, true);
        }
    };
}]);
