var componentsModules = require('../components.module');
componentsModules.directive('chatConfirmAction', [function () {
    return {
        restrict: 'EA',
        replace: true,
        scope: {
            confirm: '=confirm'
        },
        transclude: true,
        templateUrl: 'ingaia-chat/confirm-action/confirm-action.tpl.html',
        link: function (scope, element) {

            /* Expected data ============== */
            /*
             scope.confirm = {
             icon: 'ing ing-exclamation-circle',
             title: 'Title of the action',
             text: 'Explaining text about the action',
             buttons: [
             {
             label: 'Cancelar',
             class: 'primary',
             action: scope.cancel
             },
             {
             label: 'Excluir',
             class: 'secondary',
             action: scope.confirm
             }
             ]
             };
             */
            scope.confirm.destroy = function () {
                scope.confirm = null;
            };

            scope.confirm.closeAfterAction = (scope.confirm.closeAfterAction != undefined) ? scope.confirm.closeAfterAction : true;

            scope.evalAction = function (action) {
                scope.$eval(action);
                if (scope.confirm.closeAfterAction)
                    scope.confirm = null;
            };

            scope.$on('$destroy', function () {
                element[0].remove();
            });
        }
    }
}]);
