var componentsModules = require('../components.module');
componentsModules.directive("chatDropdown", ['$document', function ($document) {
    return {
        restrict: "E",
        templateUrl: function (scope, elem) {
            if (elem.template == undefined || elem.template == '')
                elem.template = 'ingaia-chat/dropdown/dropdown.tpl.html';
            return elem.template;
        },
        scope: {
            placeholder: "@",
            list: "=",
            selected: "=",
            property: "@",
            dropup: "=?",
            onchange: "=?"
        },
        link: function (scope, element) {
            scope.listVisible = false;
            scope.isPlaceholder = true;

            var calcPosition = function () {
                var drop = element[0].querySelectorAll('.dropdown-list')[0];
                var display = element[0].querySelectorAll('.dropdown-display')[0];
                if (scope.dropup)
                    drop.style.top = -(drop.offsetHeight) + 'px';
                else
                    drop.style.top = display.offsetHeight + 'px';
            }

            scope.select = function (newItem) {
                scope.isPlaceholder = false;
                var oldItem = scope.selected;
                scope.selected = newItem;
                if (scope.onchange !== undefined)
                    scope.onchange(newItem, oldItem);
                scope.toggle();
            };

            scope.isSelected = function (item) {
                return item[scope.property] === scope.selected[scope.property];
            };

            scope.toggle = function () {
                scope.listVisible = !scope.listVisible;
                setTimeout(calcPosition, 100);
            };

            scope.$watch("selected", function (value) {
                if (value) {
                    scope.isPlaceholder = scope.selected[scope.property] === undefined;
                    scope.display = scope.selected[scope.property];
                }
            });

            window.addEventListener('resize', function () {
                scope.$apply(function () {
                    scope.listVisible = false;
                });
            });

            // Close dropdown when clicking outside
            $document.on('click', function (e) {
                if (e.target !== element[0] && !element[0].contains(e.target)) {
                    scope.listVisible = false;
                }
            });
        }
    }
}]);