var componentsModules = require('../components.module');
componentsModules.directive("dummyImage", ['$http', function ($http) {
    return {
        restrict: "A",
        scope: {
            width: "@?",
            height: "@?",
            dummyImage: "=?",
            dummyText: "=",
            bgcolor: "@?",
            color: "@?",
            randomColor: "@?"
        },
        link: function (scope, element, attrs) {

            var bgcolor, color, getDummy, getRandomColor, height, imgDummy, length, width;

            bgcolor = scope.bgcolor || "E0E0E0";
            color = scope.color || "818282";

            getRandomColor = function () {
                var hex, i, letters;
                letters = '0123456789ABCDEF'.split('');
                hex = '';
                i = 0;
                while (i < 6) {
                    hex += letters[Math.floor(Math.random() * 16)];
                    i++;
                }
                return hex;
            };

            if (scope.randomColor === 'true') {
                bgcolor = getRandomColor();
                color = "FFFFFF";
            }

            width = scope.width || 40;
            height = scope.height || 40;
            length = scope.length || 2;

            if (scope.dummyImage === "" || scope.dummyImage === void 0) {
                // TODO: Change user's placeholder image path
                imgDummy = "../dist/img/icon-single-user.png";
                attrs.$set('src', imgDummy);
            }

            getDummy = function () {
                if (scope.dummyImage === "" || scope.dummyImage === void 0) {
                    if (scope.dummyText != null) {
                        var str = scope.dummyText.substr(0, length);
                        var from = "ãàáäâẽèéëêìíïîõòóöôùúüûñç·/_,:;";
                        var to = "aaaaaeeeeeiiiiooooouuuunc------";
                        for (var i = 0, l = from.length; i < l; i++) {
                            str = str.replace(new RegExp(from.charAt(i), 'g'), to.charAt(i));
                        }

                        scope.dummyImage = "//dummyimage.com/" + width + "x" + height + "/" + bgcolor + "/" + color + ".png&text=" + str;
                        attrs.$set('src', scope.dummyImage);

                        element[0].onerror = function () {
                            angular.element(element).addClass('icon-img icon-single-user');
                        };

                    }
                } else {
                    return attrs.$set('src', scope.dummyImage);
                }
            };

            scope.$watchCollection('[dummyImage, dummyText]', function () {
                getDummy();
            });
        }
    };
}]);