var componentsModules = require('../components.module');
componentsModules.directive("chatFilterIcon", ['ChatProductTags', function (ChatProductTags) {
    return {
        restrict: 'EA',
        scope: {
            icon: '=chatFilterIcon'
        },
        link: function (scope, element) {

            angular.element(element).addClass(getIcon(scope.icon));

            scope.$watch('icon', function (n, o) {
                if (n != undefined) {
                    var oldIcon = getIcon(o);
                    var newIcon = getIcon(n);

                    angular.element(element)
                        .removeClass(oldIcon)
                        .addClass(newIcon);
                }
            });

            function getIcon(id) {
                switch (id) {
                    case 'imob':
                        return "ing-home";
                    case 'community':
                        return "ing-ingaia-ico";
                    case 'incorp':
                        return "ing-building";
                    default:
                        return "ing-link-02";
                }
            };
        }
    }
}]);