var componentsModules = require('../components.module');

componentsModules.directive('chatHumanDate', ['$interval', '$filter', function ($interval, $filter) {
    return {
        restrict: 'A',
        link: function (scope, element, attrs) {

            var setHumanDate = function() {
                var date = $filter('humanDate')(attrs.chatHumanDate);
                element.text(date);
            }

            attrs.$observe('chatHumanDate', function (newVal) {
                setHumanDate();
            });

            var dateInterval = $interval(setHumanDate, 60000);

            scope.$on('$destroy', function() {
                $interval.cancel(dateInterval);
            });            
        }
    };
}]);