var componentsModules = require("../components.module");
componentsModules.directive("ingaiachat", [
  "ChatErrors",
  "ChatNavigator",
  "ChatMessageLog",
  "ChatUser",
  function(ChatErrors, ChatNavigator, ChatMessageLog, ChatUser) {
    return {
      restrict: "EA",
      templateUrl: "ingaia-chat/login/login.tpl.html",
      replace: true,
      scope: {
        profile: "=profile"
      },
      controllerAs: "vm",
      controller: [
        "$scope",
        "$timeout",
        "ChatAPI",
        "ChatToaster",
        "ChatSidebar",
        function($scope, $timeout, ChatAPI, ChatToaster, ChatSidebar) {
          var vm = this;

          // Display messages (errors, infos, warnings, etc)
          vm.toaster = new ChatToaster();

          // Toggle Chat ========================
          vm.isCollapsed = false;

          vm.chatToggle = function() {
            vm.isCollapsed = !vm.isCollapsed;
            window.parent.postMessage({ collapsed: vm.isCollapsed }, "*");
          };

          vm.chatOpen = function() {
            vm.isCollapsed = false;
          };

          vm.chatClose = function() {
            vm.isCollapsed = true;
          };

          vm.popOutWindow = function() {
            window.open(
              document.URL,
              "_blank",
              "location=no,height=500,width=450,scrollbars=yes,status=yes"
            );
          };

          // TABS ===============================================
          vm.tab = ChatSidebar.tab.init();
          vm.tab.open("form-login");

          vm.currentConversation = {
            isGroup: true,
            roomId: "54das65da1sdfgdfg5df4g",
            name: "Ricardo",
            messages: [],
            index: 0,
            unreadMessages: 0
          };

          vm.appendSampleMessages = function() {
            $timeout(function() {
              vm.currentConversation.messages = [
                {
                  message:
                    "Seja bem-vindo ao nosso atendimento online. Em que podemos ajudá-lo?",
                  messageDate: new Date().toISOString(),
                  read: true,
                  sender: {
                    id: 123,
                    name: "João",
                    photo: "",
                    productTag: "sites"
                  },
                  system: true
                }
              ];
            }, 1000);
          };

          // $scope.hideLogin = function () {
          //     $scope.connected = false;
          // };
          //
          // $scope.sampleMessages = [
          //     {
          //         "senderId": 24,
          //         "message": "Olá, meu nome é Jessé. Como posso ajudar?",
          //         "messageDate": "2016-10-10T13:33:06.037Z"
          //     },
          //     {
          //         "senderId": 0,
          //         "message": "Gostaria de saber se você possui algum imóvel pra locação na Barra da Tijuca",
          //         "messageDate": "2016-10-10T13:33:06.037Z"
          //     }
          // ];
          //
          // $scope.isMyMessage = function (senderId) {
          //     return senderId == 24;
          // }
          //
          // $scope.sample = {};
          // $scope.sample.messagetext = "";
          //
          // var sampleResponse = [
          //     "Lorem ipsum dolor sit amet, consectetur adipiscing elit.",
          //     "Sed odio tortor, lacinia vitae finibus eu, tincidunt ac eros.",
          //     "Vestibulum iaculis mollis leo, in malesuada arcu congue nec.",
          //     "Vestibulum sodales leo sit amet risus lobortis laoreet. ",
          //     "Suspendisse dignissim posuere massa, finibus volutpat nunc cursus pharetra.",
          //     "Curabitur nec nunc lobortis, viverra felis sed, hendrerit quam.",
          //     "Vestibulum tempor massa in turpis dictum, sit amet scelerisque nulla pellentesque.",
          //     "Suspendisse potenti.",
          //     "Suspendisse nec auctor ex.",
          //     "Vestibulum elementum elementum ultricies.",
          //     "Nunc vehicula sagittis magna nec dictum.",
          //     "Phasellus in lobortis nibh.",
          //     "Morbi posuere, ante eu sodales congue, est nunc ornare nisl, at sollicitudin augue justo ornare nisi.",
          //     "Donec in sagittis neque, vitae laoreet sem.",
          //     "Maecenas dictum lobortis tortor, id facilisis nulla pellentesque a."
          // ];
          //
          // $scope.sendLoginMessage = function (event) {
          //     if (event.keyCode == 13) {
          //         event.preventDefault();
          //         if ($scope.sample.messagetext.length) {
          //
          //             $scope.sampleMessages.push({
          //                 "senderId": 0,
          //                 "message": $scope.sample.messagetext,
          //                 "messageDate": new Date().toISOString()
          //             });
          //
          //             $scope.sample.messagetext = "";
          //
          //             // Mock a chat response
          //             $timeout(function () {
          //                 $scope.sampleMessages.push({
          //                     "senderId": 24,
          //                     "message": sampleResponse[Math.floor(Math.random() * sampleResponse.length)],
          //                     "messageDate": new Date().toISOString()
          //                 });
          //             }, Math.floor(Math.random() * 5000));
          //         }
          //     }
          // };
          //
          // var vm = this;
          // vm.contactsUrl = $scope.contactsUrl;
          // vm.proxy = ChatAPI.proxy();
          //
          // // Errors =========================
          // var Errors = new ChatErrors;
          // vm.errors = Errors.errors;
          // vm.getError = Errors.getError;
          //
          // // Toggle Chat ====================
          // vm.isOpen = true;
          // vm.chatToggle = function () {
          //     vm.isOpen = !vm.isOpen;
          //     $scope.$emit('chatToggle');
          // };
          //
          // vm.login = function () {
          //     $scope.connected = true;
          // };
        }
      ],
      link: function(scope, element) {
        window.onload = applyCustomStyle;

        function addCSSRule(sheet, selector, rules, index) {
          if ("insertRule" in sheet) {
            sheet.insertRule(selector + "{" + rules + "}", index);
          } else if ("addRule" in sheet) {
            sheet.addRule(selector, rules, index);
          }
        }

        function getParamValue(paramName) {
          var url = window.location.search.substring(1); //get rid of "?" in querystring
          var qArray = url.split("&"); //get key-value pairs
          for (var i = 0; i < qArray.length; i++) {
            var pArr = qArray[i].split("="); //split key and value
            if (pArr[0] == paramName) return decodeURIComponent(pArr[1]); //return value
          }
        }

        function addHexHash(hex) {
          return hex ? "#" + hex : null;
        }

        function applyCustomStyle() {
          try {
            var style = document.createElement("style");
            style.id = "chatCustomStyle";

            // WebKit hack :(
            style.appendChild(document.createTextNode(""));

            // Add the <style> element to the page
            document.head.appendChild(style);
            var bgDefault = addHexHash(getParamValue("bg0"));
            var bgPrimary = addHexHash(getParamValue("bg1"));
            var colorPrimary = addHexHash(getParamValue("color1"));
            var bgSecondary = addHexHash(getParamValue("bg2"));
            var colorSecondary = addHexHash(getParamValue("color2"));

            if (bgDefault) {
              addCSSRule(
                document.styleSheets[0],
                ".chat-sidebar, .chat-tab-content, .chat-tab-footer, .chat-panel-footer",
                "background-color:" + bgDefault + " !important;"
              );
            }

            if (bgPrimary) {
              addCSSRule(
                document.styleSheets[0],
                ".chat-navbar, .chat-navbar-brand:hover, .chat-navbar a:hover, .chat-navbar a:focus",
                "background-color:" + bgPrimary + " !important;"
              );
              addCSSRule(
                document.styleSheets[0],
                ".secondary",
                "background-color:" + bgPrimary + " !important;"
              );
            }

            if (colorPrimary) {
              addCSSRule(
                document.styleSheets[0],
                ".chat-navbar-brand, .chat-navbar ul>li>a, .secondary",
                "color:" + colorPrimary + " !important;"
              );
              addCSSRule(
                document.styleSheets[0],
                ".chat-navbar ul>li:hover>a:after",
                "background-color:" + colorPrimary + " !important;"
              );
            }

            // if (bgSecondary) {
            //     addCSSRule(document.styleSheets[0], ".chat-navbar ul>li:hover>a:after", "background-color:" + bgSecondary + " !important;");
            // }

            if (colorSecondary) {
              addCSSRule(
                document.styleSheets[0],
                ".chat-tab-content, .secondary, .chat-tab-list-item, input:not([type=radio])",
                "color:" + colorSecondary + " !important;"
              );
            }
          } catch (err) {
            console.error("Error applying custom styles");
          }
        }
      }
    };
  }
]);
