var componentsModules = require('../../components.module');
componentsModules.directive('popupGroupedTab', ['$timeout', 'ChatPopups', function ($timeout, ChatPopups) {
    return {
        require: '^chatSidebar',
        restrict: 'EA',
        replace: true,
        templateUrl: 'ingaia-chat/popup/grouped-tab/popup-grouped-tab.tpl.html',
        scope: {
            popups: '=popupGroupedTab'
        },
        link: function (scope) {

            scope.contacts = ChatPopups.grouped;
            scope.groupedUnreads = 0;

            var countUnreadMessages = function () {
                scope.groupedUnreads = 0;
                scope.contacts.forEach(function (contact) {
                    scope.groupedUnreads += contact.unreadMessages;
                });
            };

            var hightlightTab = function () {
                ChatPopups.highlight(scope);
            };

            window.inGaiaChat_API.on('chatReceiveMessage', countUnreadMessages);
            window.inGaiaChat_API.on('setReadMessages', countUnreadMessages);
            window.inGaiaChat_API.on('popupGroupedHighlight', hightlightTab);

            scope.$on('$destroy', function () {
                window.inGaiaChat_API.off('chatReceiveMessage', countUnreadMessages);
                window.inGaiaChat_API.off('setReadMessages', countUnreadMessages);
                window.inGaiaChat_API.off('popupGroupedHighlight', hightlightTab);
            });
        }
    };
}]);
