var appConfig = require('../../../config');
var Helpers = require('../../../helpers');
var componentsModules = require('../../components.module');

componentsModules.directive("chatPopupMessage", ['ChatAPI', '$timeout', '$filter', function (ChatAPI, $timeout, $filter) {
    return {
        restrict: 'EA',
        replace: true,
        templateUrl: 'ingaia-chat/popup/message/popup-message.tpl.html',
        link: function (scope, element, attrs) {
            if (scope.message.hasFile) {
                if (scope.message.fileObjectKey) {
                    if (!scope.message.loadedFile) {
                        var link = appConfig.galleryUrl + 'room/' + scope.$parent.popup.roomId + '/file/' + scope.message.fileObjectKey;
                        var embedConfig = {
                            url: null,
                            fileType: scope.message.fileType,
                            fileName: scope.message.message,
                            link: link
                        };

                        if (scope.message.fileType && Helpers.file.isImage(scope.message.message)) {
                            // If file type is image, request the thumbnail
                            ChatAPI.upload.getImage(scope.message.fileObjectKey).then(function (response) {
                                $timeout(function () {
                                    embedConfig.url = response.data;
                                    // Render image inside message
                                    scope.message.message = $filter('embedUrl')(embedConfig);
                                });
                            }, function (err) {
                                console.error("Erro ao carregar arquivo anexo.");
                            });
                        } else {
                            // If file is of any other type
                            scope.message.message = $filter('embedUrl')(embedConfig);
                        }
                        
                        // Add prop flag to avoid nested rendering (duplicates)
                        scope.message.loadedFile = true;
                    }
                }
            } else {
                // Search for urls inside message, if doesn't exist just return the message string 
                scope.message.message = $filter('embedUrl')({ url: scope.message.message });
            }
        }
    }
}]);
