var componentsModules = require('../../components.module');
componentsModules.directive('popupPosition', ['ChatPopups', 'ChatSidebar', function (ChatPopups, ChatSidebar) {
    return {
        restrict: 'A',
        link: function (scope, element, attrs) {

            var popupElemWidth, sidebarElemWidth, offset, $sidebar;

            var updatePosition = function (popupCount) {
                if (ChatPopups.list.length) {
                    setTimeout(function () {
                        popupElemWidth = $('.popup-tab').outerWidth(true);
                        $sidebar = $('#chat-sidebar');
                        sidebarElemWidth = 0;

                        if (ChatSidebar.settings.layoutMin) {
                            sidebarElemWidth = $sidebar.outerWidth(true);
                        } else {
                            if (!ChatSidebar.settings.collapsed)
                                sidebarElemWidth = $sidebar.outerWidth(true);
                        }

                        offset = ((popupElemWidth) * parseInt(popupCount)) + sidebarElemWidth;
                        $(element).css('right', offset);

                    }, 100);
                }
            };

            // Reorder popups when change index
            attrs.$observe('popupPosition', function (newVal) {
                ChatPopups.updateIndex();
                updatePosition(newVal);
            });

            window.inGaiaChat_API.on('chatWidgetChange', function () {
                updatePosition(attrs.popupPosition);
            });

            window.inGaiaChat_API.on('chatVisibilityChange', function () {
                updatePosition(attrs.popupPosition);
            });

            $(window).resize(function () {
                updatePosition(attrs.popupPosition);
            })
        }
    }
}]);
