var componentsModules = require('../../components.module');
componentsModules.directive('chatSidebarSettings', ['ChatAPI', 'ChatContacts', 'ChatMessageLog', function (ChatAPI, ChatContacts, ChatMessageLog) {
    return {
        restrict: 'AE',
        replace: true,
        templateUrl: 'ingaia-chat/sidebar/settings/sidebar-settings.tpl.html',
        link: function (scope) {

            scope.sendReportAccess = function () {
                ChatAPI.sendReportAccess().then(function (response) {
                    // Success
                }, function (err) {
                    console.error('Erro ao enviar estatística de relatório');
                });
            };

            /**
             * Unblock a contact.
             * @method
             * @return {Array}
             */
            scope.unblock = function (blocked) {
                var errorUnblock = function (err) {
                    $scope.toaster.add({
                        type: 'error',
                        message: ChatMessageLog.UNBLOCK.ERROR,
                        dismissable: true
                    });
                };

                ChatContacts.unblock(blocked, null, errorUnblock);
            };
        }
    }
}]);
