var componentsModules = require('../components.module');
componentsModules.directive('chatSplitScreen', ['ChatSidebar', function (ChatSidebar) {
    return {
        restrict: 'A',
        link: function (scope, element, attrs) {
            if (attrs.chatSplitScreen != "") {

                var splitScreen = function (state) {
                    var $container = $(attrs.chatSplitScreen);
                    if ($container) {
                        if (state)
                            $container.addClass('chat-split-screen');
                        else
                            $container.removeClass('chat-split-screen');
                    }
                };

                window.inGaiaChat_API.on('chatWidgetChange', function (layoutMin) {
                    splitScreen(!layoutMin);
                });

                window.inGaiaChat_API.on('chatVisibilityChange', function (state) {
                    if (ChatSidebar.settings.layoutMin)
                        splitScreen(!ChatSidebar.settings.layoutMin);
                    else
                        splitScreen(!state.collapsed);
                });

                window.inGaiaChat_API.on('chatSettingsLoaded', function () {
                    if (ChatSidebar.settings.layoutMin)
                        splitScreen(!ChatSidebar.settings.layoutMin);
                    else
                        splitScreen(!ChatSidebar.settings.collapsed);
                });
            }
        }
    }
}]);