var componentsModules = require('../components.module');
componentsModules.directive("chatStatus", function () {
    return {
        restrict: 'EA',
        scope: {
            status: '=chatStatus'
        },
        replace: true,
        template: '<span class="chat-status-indicator"></span>',
        link: function (scope, element) {

            angular.element(element).addClass(getStatus(scope.status));

            scope.$watch('status', function (n, o) {
                if (n != undefined) {
                    var oldStatus = getStatus(o);
                    var newStatus = getStatus(n);

                    angular.element(element)
                        .removeClass(oldStatus)
                        .addClass(newStatus);
                }
            });

            function getStatus(status) {
                switch (status) {
                    case 1:
                        return "online";
                    case 2:
                        return "busy";
                    case 3:
                        return "offline";
                    case 4:
                        return "away";
                }
            };
        }
    }
});