var componentsModules = require("../components.module");
componentsModules.directive("title", [
  "ChatAPI",
  "ChatUser",
  "ChatConversations",
  function(ChatAPI, ChatUser, ChatConversations) {
    return {
      restrict: "E",
      link: function(scope, element) {
        var updateNotifications = function(val) {
          var title = element[0].innerText.replace(/(\().+?(\)\s)/g, "");
          if (val && val > 0) {
            element[0].innerText = "(" + val + ") " + title;
          } else {
            element[0].innerText = title;
          }
        };

        window.inGaiaChat_API.on("chatConnected", function() {
          var User = ChatUser.get();
          ChatAPI.getTotalNotifications({
            userId: User.id,
            productTag: User.productTag
          }).then(
            function(response) {
              ChatConversations.unreads = parseInt(response.data);
              window.inGaiaChat_API.emit(
                "chatNotificationUpdate",
                ChatConversations.unreads
              );
            },
            function(err) {
              console.error(err.statusText);
            }
          );
        });

        window.inGaiaChat_API.on("chatNotificationUpdate", function(count) {
          updateNotifications(count);
        });
      }
    };
  }
]);
