var inGaiaChat_API = {
  events: {},
  on: function(eventName, fn) {
    this.events[eventName] = this.events[eventName] || [];
    this.events[eventName].push(fn);
  },
  off: function(eventName, fn) {
    if (this.events[eventName]) {
      for (var i = 0; i < this.events[eventName].length; i++) {
        if (this.events[eventName][i] === fn) {
          this.events[eventName].splice(i, 1);
          break;
        }
      }
    }
  },
  emit: function(eventName, data) {
    if (this.events[eventName]) {
      this.events[eventName].forEach(function(fn) {
        fn(data);
      });
    }
  }
};

inGaiaChat_API.start = function(data) {
  this.emit("chatStart", data);
};

inGaiaChat_API.toggle = function(data) {
  this.emit("chatToggle", data);
};

inGaiaChat_API.open = function() {
  this.emit("chatOpen");
};

inGaiaChat_API.close = function() {
  this.emit("chatClose");
};

inGaiaChat_API.inviteToChat = function(user, property) {
  this.emit("firstContactCustom", { user: user, property: property });
};

window.inGaiaChat_API = inGaiaChat_API || {};

module.exports = inGaiaChat_API;
