var filterModule = require('../factories.module');
filterModule.factory("alignSvc", ['positionSvc', function (positionSvc) {
    return {
        pos: function (element, tooltip, align) {
            //get dimensions including padding+border
            var elHeight = $(element).outerHeight();
            var elWidth = $(element).outerWidth();
            var ttWidth = tooltip.outerWidth();
            var ttHeight = tooltip.outerHeight();
            var elPos = positionSvc.global(element);
            var pos;

            var getScroll = function () {
                return {
                    y: window.pageYOffset || document.documentElement.scrollTop,
                    x: window.pageXOffset || document.documentElement.scrollLeft
                }
            };

            var scrollYOffset = getScroll().y;
            // var scrollXOffset = getScroll().x;

            switch (align) {
                case 'left':
                    pos = {
                        top: (elPos.top + elHeight / 2 - ttHeight / 2) - scrollYOffset,
                        left: elPos.left - ttWidth
                    };
                    break;
                case 'right':
                    pos = {
                        top: (elPos.top + elHeight / 2 - ttHeight / 2) - scrollYOffset,
                        left: elPos.left + elWidth
                    };
                    break;
                case 'bottom':
                    pos = {
                        top: (elPos.top + elHeight) - scrollYOffset,
                        left: elPos.left + elWidth / 2 - ttWidth / 2
                    };
                    break;
                default:
                    pos = {
                        top: (elPos.top - ttHeight) - scrollYOffset,
                        left: elPos.left + elWidth / 2 - ttWidth / 2
                    };
                    break;
            }
            return pos;
        }
    }
}]);