var factoriesModules = require('../factories.module');
factoriesModules.factory('ChatErrors', function () {
    var Errors = function () {
        this.errors = [];

        this.removeAll = function () {
            this.errors = [];
        };

        // Shows specific error code
        this.setError = function (code, message, icon, type, dismissable) {
            var error;

            error = {
                code: code,
                message: message
            };

            if (icon != undefined)
                error.icon = icon;

            if (type != undefined)
                error.type = type;

            if (dismissable != undefined)
                error.dismissable = type;

            var exist = false;

            for (var i = 0; i < this.errors.length; i++) {
                if (this.errors[i].code == code) {
                    this.errors[i] = error;
                    exist = true;
                    break;
                }
            }

            if (!exist)
                this.errors.push(error);
        };
        this.getError = function (code) {
            var errors;
            errors = this.errors.filter(function (error) {
                return parseInt(error.code) === parseInt(code);
            });
            if (errors.length)
                return errors[0];
            else
                return false;
        };
        this.removeError = function (code) {
            var errors;
            errors = this.errors;

            if (errors.length > 0) {
                errors.forEach(function (error, key) {
                    if (parseInt(error.code) === parseInt(code))
                        errors.splice(key, 1);
                });
            } else {
                return false;
            }
        }
    };
    return Errors;
});
