var factoriesModules = require('../factories.module');
factoriesModules.factory('ChatMessageLog', function () {
    return {
        "ERROR": {
            "LOGIN": "Usuário não autenticado. Efetue login novamente para utilizar o chat.",
            "CONNECTION": "Erro ao iniciar conexão com o chat. Atualize a página e tente efetuar login novamente.",
            "DISCONNECTED": "Você está desconectado",
            "RECONNECTION": "Não foi possível reconectar automaticamente. Atualize a página ou tente novamente mais tarde.",
            "NOT_ALLOWED": "Não autorizado",
            "BROWSER_SUPPORT": "Seu navegador não suporta devidamente as funcionalidades do chat. Por favor, tente utilizar Chrome ou Firefox",
            "AUDIO_SUPPORT": "Seu navegador não suporta tocar arquivos de áudio.",
            "INVALID_USER": "Usuário inválido.",
            "CONNECTION_PARAMS": "Não foram informados parâmetros para conexão.",
            "SIGNALR": "Erro ao carregar SignalR.",
            "HUBS": "Erro ao carregar do Hubs."
        },
        "WARNING": {
            "CHANGE_STATUS_OFFLINE": "Altere seu status para ativar o chat."
        },
        "ACTIONS": {
            "RECONNECTING": "Reconectando...",
            "CANCEL": "Cancelar",
            "DELETE": "Excluir",
            "SAVE": "Salvar",
            "LEAVE": "Sair",
            "STAY": "Ficar",
            "BLOCK": "Bloquear",
            "UNBLOCK": "Desbloquear",
            "BACK": "Voltar"
        },
        "USER": {
            "IS_TYPING": 'está digitando...'
        },
        "STATUS": {
            "ONLINE": "Online",
            "BUSY": "Ocupado",
            "OFFLINE": "Offline",
            "AWAY": "Ausente"
        },
        "CONTACTS": {
            "ERROR": {
                "ENDPOINT": "É necessário informar a URL para listagem de contatos.",
                "LOAD": "Não foi possível carregar a sua lista de contatos.",
                "SEARCH": "Erro ao buscar contatos",
                "LOAD_BLOCKED": "Erro ao carregar lista de contatos bloqueados"
            },
            "SEARCH": {
                "NO_RESULTS": {
                    "DEFAULT": "Nenhum contato encontrado",
                    "INCORP": "Nenhum contato para incorpodora.",
                    "COMMUNITY": "Ainda não há contatos nesta lista, inicie agora mesmo uma parceria com outra imobiliária."
                }
            }
        },
        "CONVERSATIONS": {
            "ERROR": {
                "LOAD": "Não foi possível carregar a sua lista de conversas.",
                "SEARCH": "Erro ao buscar conversas"
            }
        },
        "MESSAGE": {
            "ERROR": {
                "SEND": "Erro ao enviar mensagem. Atualize a página e tente novamente.",
                "LOAD": "Erro ao carregar mensagens",
                "LOAD_MORE": "Erro ao carregar mais mensagens",
                "UPDATE": "Erro ao atualizar mensagens",
                "DELIVERY": "Não foi possível enviar sua mensagem",
                "BLOCKED": "Não foi possível enviar sua mensagem. Verifique se este contato encontra-se em sua lista de bloqueio."
            }
        },
        "UPLOAD": {
            "HELPER_LABEL": "Solte o arquivo para enviar",
            "ERROR": {
                "NOT_SUPPORTED": "Arquivo não suportado",
                "MAX_SIZE": "Tamanho máximo aceito: ",
                "MIN_SIZE": "Tamanho mínimo aceito: ",
                "PATTERN": "Formatos aceitos: "
            }
        },
        "ROOM": {
            "ERROR": {
                "ADD_PARTICIPANT": "Erro ao adicionar participante ao grupo",
                "ALREADY_ADDED": 'já foi adicionado ao grupo',
                "REMOVE_PARTICIPANT": "Erro ao remover participante do grupo",
                "LEAVE": "Erro ao sair do grupo",
                "DELETE": "Erro ao excluir grupo",
                "EDIT": "Erro ao editar nome do grupo",
                "PARTNERSHIP": "Erro ao iniciar parceria. Por favor, tente mais tarde.",
                "CREATE_GROUP": "Erro ao criar grupo."
            },
            "DELETE": {
                "TITLE": "Deseja excluir essa conversa?",
                "TEXT": "Ao excluir esta conversa, todas as mensagens serão perdidas."
            },
            "LEAVE": {
                "TITLE": "Deseja sair do grupo?",
                "TEXT": "Você não poderá mais ler e enviar mensagens para este grupo. Tem certeza de que deseja sair?"
            }
        },
        "PROFILE": {
            "ERROR": {
                "LOAD": "Não foi possível carregar o perfil do usuário no chat."
            }
        },
        "SETTINGS": {
            "LOADING": "Carregando preferências do usuário...",
            "ERROR": {
                "SAVE": "Erro ao salvar configurações",
                "LOAD": "Erro ao carregar configurações"
            }
        },
        "NAVIGATOR": {
            "ERROR": {
                "SUPPORT": "Seu navegador não suporta devidamente as funcionalidades do chat. Por favor, tente utilizar Chrome ou Firefox",
                "AUDIO": "Seu navegador não suporta tocar arquivos de áudio."
            }
        },
        "BLOCK": {
            "LABEL": "Bloquear",
            "ERROR": "Erro ao bloquear contato.",
            "CONFIRM": "Deseja bloquear este contato?",
            "WARN": "Você não receberá mais mensagens diretas e notificações dessa pessoa, mas ela estará presente em qualquer Conversa em grupo que vocês tenham em comum. Tem certeza de que deseja continuar?"
        },
        "UNBLOCK": {
            "LABEL": "Desbloquear",
            "ERROR": "Erro ao desbloquear contato.",
            "CONFIRM": "Deseja desbloquear este contato?",
            "WARN": "Para iniciar uma conversa com esse contato, é necessário que você o desbloqueie."
        },
        "DATE": {
            "AT": "às",
            "JUST_NOW": "Agora mesmo",
            "SECONDS_AGO": "Segundos atrás",
            "MINUTE_AGO": "minuto atrás",
            "MINUTES_AGO": "minutos atrás",
            "HOUR_AGO": "hora atrás",
            "HOURS_AGO": "horas atrás",
            "YESTERDAY": "Ontem",
            "DAY_AGO": "dia atrás",
            "DAYS_AGO": "dias atrás",
            "WEEKS_AGO": "semanas atrás"
        }
    }
});
