var factoriesModules = require('../factories.module');

factoriesModules.factory('ChatToaster', function () {
    var Toaster = function () {
        return {
            list: [],
            getByCode: function (code) {
                var list = this.list.filter(function (item) {
                    return parseInt(item.code) === parseInt(code);
                });
                if (list.length)
                    return list[0];
                else
                    return false;
            },
            get: function (item) {
                var list = this.list.filter(function (i) {
                    return parseInt(item.code) == parseInt(i.code) && item.message == i.message;
                });
                return list;
            },
            add: function (item) {
                var list = this.list.filter(function (i) {
                    return parseInt(item.code) == parseInt(i.code) && item.message == i.message;
                });
                if (!list.length)
                    this.list.push(item);
            },
            remove: function (item) {
                var list = [];

                if (typeof item === "number") {
                    list = this.list.filter(function (i) {
                        return parseInt(item) != parseInt(i.code);
                    });
                } else {
                    list = this.list.filter(function (i) {
                        return parseInt(item.code) == parseInt(i.code) && item.message == i.message;
                    });
                }

                this.list = list;
            },
            removeAll: function () {
                this.list = [];
            }
        }
    };
    return Toaster;
});
