var Helpers = require('../../helpers');

// Display modal full image
// $(document).on('click', '.embed-image-box', function () {

// var img = this.querySelector('img').cloneNode(true);
// var $backdrop = document.getElementById('chat-backdrop');
// var $modal = document.getElementById('chat-modal');

// if (!$backdrop) {
//     $('#chat-container').append('<div id="chat-backdrop"><div id="chat-modal" class="fade-in-down"></div></div>');
//     $backdrop = document.getElementById('chat-backdrop');
//     $modal = document.getElementById('chat-modal');
// }

// $modal.appendChild(img);
// $backdrop.style.display = 'block';

// $backdrop.onclick = function () {
//     $backdrop.style.display = 'none';
//     $modal.innerHTML = '';
// };
// });

var renderImage = function(config) {
  var template, link, img;
  link = config.link ? config.link : config.url;
  img = '<img class="embed-image-thumb" src="' + config.url + '" alt="">';
  template = '<div class="embed-image-box">';
  template += renderLink(link, img);
  if (config.fileName)
    template +=
      '<span class="embed-image-title">' + config.fileName + '</span>';
  template += '</div>';
  return template;
};

var renderIframe = function(config) {
  var template = '';
  var iframe =
    '<iframe width="100%" height="100%" src="' +
    config.url +
    '" frameborder="0"></iframe>';

  if (config.link) {
    template = renderLink(config.link, iframe);
  } else {
    template = iframe;
  }

  return template;
};

var renderLink = function(url, content) {
  url = url ? url : '';
  content = content ? content : url;
  return (
    '<a class="embed-link" href="' +
    url +
    '" target="_blank">' +
    content +
    '</a>'
  );
};

var renderGeneric = function(config) {
  var link = config.link ? config.link : config.url;
  var imgUrl = Helpers.file.getFileType(config.fileType);
  var template = '';
  var img = '<img src="' + imgUrl + '" class="embed-file-preview"/>';
  template = '<div class="embed-image-box">';
  template += renderLink(link, img);
  if (config.fileName)
    template +=
      '<span class="embed-image-title">' + config.fileName + '</span>';
  template += '</div>';
  return template;
};

var embedUrl = function(config) {
  // var config = {
  //     url: @string,
  //     fileType: @string,
  //     fileName: @string,
  //     link: @string
  // };

  if (config.fileType) {
    switch (config.fileType.toLowerCase()) {
      case 'png':
      case 'jpg':
      case 'jpeg':
      case 'gif':
      case 'bmp':
        return renderImage(config);
      case 'pdf':
      // return renderIframe(str);
      case 'doc':
      case 'docx':
      case 'ppt':
      case 'pptx':
      case 'pps':
      case 'xls':
      case 'xlsx':
      case 'csv':
        return renderGeneric(config);
      default:
        return renderLink(config.url);
    }
  }

  var pattern = /(blob|data|ftp|http|https):(\/\/)?(\w+:{0,1}\w*@)?(\S+)(:[0-9]+)?(\/|\/([\w#!:.?+=&%@!\-\/]))?/;
  var results = pattern.exec(config.url);

  if (results) {
    for (var i = 0; i < results.length; i++) {
      var targetUrl = results[i];
      if (targetUrl && pattern.test(targetUrl)) {
        if (Helpers.file.isImage(targetUrl)) {
          return config.url.replace(targetUrl, renderImage(config));
        } else if (Helpers.file.isYouTube(targetUrl)) {
          var YTUrl =
            'https://www.youtube.com/embed/' +
            Helpers.file.isYouTube(targetUrl);
          config.url = YTUrl;
          return renderIframe(config);
        } else if (Helpers.file.isPDF(targetUrl)) {
          return renderIframe(config);
        } else {
          return config.url.replace(targetUrl, renderLink(targetUrl));
        }
      }
    }
  }
  return config.url;
};

var filterModule = require('../filter.module');
filterModule.filter('embedUrl', [
  '$sce',
  function($sce) {
    return function(string, type, link) {
      return $sce.trustAsHtml(embedUrl(string, type, link));
    };
  },
]);
