var filterModule = require('../filter.module');
filterModule.filter('humanDate', ['ChatMessageLog', function (ChatMessageLog) {

    var localeDate = function (date) {
        return date.toLocaleString(navigator.language, {day: '2-digit', month: '2-digit', year: '2-digit', hour: '2-digit', minute:'2-digit'});
    };

    var prettyDate = function (time) {

        var date = new Date(time);
        var diff = Math.round(((+new Date()) - date) / 1000);
        var day_diff = Math.floor(diff / 86400);

        if (isNaN(day_diff) || day_diff >= 31) {
            return localeDate(date);
        }

        return day_diff == 0 && (
            diff < 60 && ChatMessageLog.DATE.SECONDS_AGO ||
            diff < 120 && "1 " + ChatMessageLog.DATE.MINUTE_AGO ||
            diff < 3600 && Math.floor(diff / 60) + " " + ChatMessageLog.DATE.MINUTES_AGO ||
            diff < 7200 && "1 " + ChatMessageLog.DATE.HOUR_AGO ||
            diff < 86400 && Math.floor(diff / 3600) + " " + ChatMessageLog.DATE.HOURS_AGO) ||
            day_diff == 1 && ChatMessageLog.DATE.YESTERDAY ||
            // Added tomorrow
            day_diff == -1 && ChatMessageLog.DATE.JUST_NOW ||
            // Added within days
            // || day_diff < 7 && day_diff + " " + ChatMessageLog.DATE.DAYS_AGO ||
            // day_diff < 31 && Math.ceil(day_diff / 7) + " " + ChatMessageLog.DATE.WEEKS_AGO
            localeDate(date);
    };

    return function (time) {
        return prettyDate(time);
    };
}]);
