var appConfig = require('../config');

var Helpers = {
    file: {
        isImage: function (url, isExtension) {
            if (!url) {
                return false;
            } else {
                if (isExtension) {
                    return (url.toLowerCase().match(/^(image\/)?\.?(jpe?g|jpg|gif|png|bmp)/) != null);
                } else {
                    return (url.toLowerCase().match(/^(data:image)|\.(jpe?g|jpg|gif|png|bmp)/) != null);
                }
            }
        },
        isYouTube: function (url) {
            var pattern = /^(?:https?:\/\/)?(?:www\.)?(?:youtu\.be\/|youtube\.com\/(?:embed\/|v\/|watch\?v=|watch\?.+&v=))((\w|-){11})(?:\S+)?$/;
            return (url.match(pattern)) ? RegExp.$1 : false;
        },
        isPDF: function (url) {
            return (url.match(/^(data:application\/pdf)|\.(pdf)$/) != null);
        },
        getFileExtension: function (str) {
            var fileExtensionPattern = /\.([0-9a-z]+)(?=[?#])|(\.)(?:[\w]+)$/gmi;
            var fileExtension = str.match(fileExtensionPattern)[0] ? str.match(fileExtensionPattern)[0].replace('.', '') : null;
            return fileExtension;
        },
        getFileType: function (type) {
            switch (type) {
                case "pdf":
                    return appConfig.galleryBaseUrl + 'medias/imgs/pdf.png';
                case "doc":
                case "docx":
                    return appConfig.galleryBaseUrl + 'medias/imgs/doc.png';
                case "ppt":
                case "pptx":
                case "pps":
                    return appConfig.galleryBaseUrl + 'medias/imgs/ppt.png';
                case "xls":
                case "xlsx":
                case "csv":
                    return appConfig.galleryBaseUrl + 'medias/imgs/excel.png';
                default:
                    return appConfig.galleryBaseUrl + 'medias/imgs/file.png';
            }
        }
    }
}

module.exports = Helpers;
